from bpy.types import WorkSpaceTool
from pathlib import Path


class erase_voxel_tool(WorkSpaceTool):
    """Removes voxels under cursor"""
    bl_space_type = 'VIEW_3D'
    bl_context_mode = 'EDIT_MESH'
    bl_idname = "mesh.vox_erase_voxel_tool"
    bl_label = "Erase voxel"
    bl_description = (
        "Vox\n"
        "Erase voxels"
    )
    bl_icon = (Path(__file__).parent / "" / "ops.mesh.erase_voxel").as_posix()
    bl_widget = "EDIT_MESH_GGT_vox_tool"
    bl_cursor = "ERASER"
    bl_keymap = (
        ("mesh.vox_draw_voxel",
         {"type": 'LEFTMOUSE', "value": 'ANY'},
         {"properties": [("remove", True)]}),
        ("mesh.vox_prview_voxel",
         {"type": 'MOUSEMOVE', "value": 'ANY'},
         {"properties": [("add_new", False), ("tool_color", (1, 0, 0))]}),
    )

    def draw_settings(context, layout, tool):
        props = tool.operator_properties("mesh.vox_draw_voxel")
        layout.prop(props, "operatormode")
